//+------------------------------------------------------------------+
//|                                                                  |
//|                         property of janus2122@exemail.com.au
//|                                            
//+------------------------------------------------------------------+
//   SEE   oncalculate on line 1003

// redraw of dashboard set on line 992

#property copyright ""
#property link      "janus2122@exemail.com.au"
#property version   "2.0"
#property indicator_chart_window
#property strict




enum ENUM_SWITCH{
    SWITCH_ENABLE = 1,  //ENABLE
    SWITCH_DISABLE = 0   //DISABLE
};

enum ENUM_SYMBOL_SOURCE{
   AUTO_LIST,     //Auto List
   USER_LIST,     //User List
};


enum SHOW_HIDE{
    SHOW = 1, //SHOW
    HIDE = 0  //HIDE
};

enum ENUM_MA_METHODS{
    MA_SMA  = 0,      //Simple 
    MA_EMA  = 1,      //Exponential
    MA_SMMA = 2,      //Smoothed
    MA_LWMA = 3,      //Linear Weighted
    MA_TTLP = 4       //Low Pass
};





extern ENUM_SYMBOL_SOURCE SymbolSource = USER_LIST;                      //Symbols Source
input string	          User_Symbol_List_Inpt = "EURAUD,GBPAUD,AUDCAD,EURCAD,GBPCAD,NZDCAD,USDCAD,AUDCHF,CADCHF,EURCHF,GBPCHF,NZDCHF,USDCHF,EURGBP,AUDJPY,CADJPY,CHFJPY,EURJPY,GBPJPY,NZDJPY,USDJPY,AUDNZD,EURNZD,GBPNZD,AUDUSD,EURUSD,GBPUSD,NZDUSD,XAUUSD";//User List
char                      User_Symbol_List_Separator = ',';

input string ;
input string indicators_Path = "T4T LowPass v1.0";                      //T4T LowPass v1.0  file directory

input string ;
input string               MA_1_Settings;                                    //Fast MA
input int                  MA_1_Period           = 5;                        //Period
input ENUM_MA_METHODS      MA_1_Method          = MA_EMA;                    //Method
input ENUM_APPLIED_PRICE   MA_1_Applied_Price    = PRICE_CLOSE;              //Applied Price


input string ;
input string               MA_2_Settings;                                   //Slow MA
input int                  MA_2_Period           = 12;                       //Period
input ENUM_MA_METHODS       MA_2_Method          = MA_EMA;                  //Method
input ENUM_APPLIED_PRICE   MA_2_Applied_Price    = PRICE_CLOSE;             //Applied Price


input string ;
input  string   Timeframes_Settings;                          //Dashboard Timeframes
input SHOW_HIDE show_M1 = HIDE;                               //M1
input SHOW_HIDE show_M5 = HIDE;                               //M5
input SHOW_HIDE show_M15 = SHOW;                              //M15
input SHOW_HIDE show_M30= HIDE;                               //M30
input SHOW_HIDE show_H1 = SHOW;                               //H1
input SHOW_HIDE show_H4 = SHOW;                               //H4
input SHOW_HIDE show_D1 = SHOW;                               //D1
input SHOW_HIDE show_W1 = SHOW;                               //W1
input SHOW_HIDE show_MN1 = HIDE;                              //MN1



input string ;
input string         Notifications_Settings;                  //Notifcations
input ENUM_SWITCH    phone_Notification  = SWITCH_DISABLE;    //Phone 
input ENUM_SWITCH    email_Notification  = SWITCH_DISABLE;    //Email 
input ENUM_SWITCH    alerts_Notification = SWITCH_DISABLE;    //MT4 Alerts


input string ;
input color dash_Colors_Setting;                               //Dashboard Colors
input color dash_Background_Color       = C'0,0,57';          //Background 
input color maximise_Button_Color       = C'0,0,245';         //Dash Buttons
input color rows_Odd_Color              = C'0,0,47';          //Rows Color 1
input color rows_Even_Color             = C'0,2,54';          //Rows Color 2
input color pairs_Color                 = C'255,255,255';     //Pairs
input color active_Color                = C'0, 153, 255';     //Active Pair/Timeframe
input color title_Background_Color      = C'0,0,77';          //Top Bar
input color title_Color                 = C'207,207,207';     //Title
input color headers_Color               = C'187,187,187';     //Timeframes   
input color dash_Buttons_Color          = C'187,187,187';     //Dash Buttons

input color  buy_Text_Color             = C'0, 102, 0';               //Bullish Signal
input color  sell_Text_Color            = C'153, 0, 0';             //Bearish Signal
input color  bars_Count_Color           = C'255,255,254';           //Bars to Crossing




//Text
string maximise_Icon = CharToString((char)113);
string resize_Icon = "+";
string minimise_Icon = "—";
string close_Icon = "X";


//Dash dimensions
int chart_Width;
int chart_Height;

double dash_Width = 500;
double dash_Height = 200;
double dash_Y = 10;
double dash_X = 20;


// Inner dimensions
double title_Height = 12;


double header_Height =  30  ;

double pairs_Width = 60;
double signals_Width = 60;
double header_Width = signals_Width;
double row_Height = 16;



//font Sizes
double title_Font_Size = 10;
double headers_Font_Size = 10;
double pairs_Font_Size = 9;
double signals_Font_Size = 8;
double resize_Font_Size = 8;
double minimise_Font_Size = 8;
double close_Font_Size = 10;


//Indents
double title_Indent = 5;
double title_V_Indent = 2;
double headers_Indent = 15;
double headers_V_Indent = 13;
double pairs_Indent = 5;
double signals_Indent = 14;   
double rows_V_Indent = 4;  
double minimise_Indent =40;
double close_Indent = 15;
double resize_Indent = 4;
  
bool dashboard_hidden = false;


//Repositioning & Resizing dashboard
double original_Event_X = 0;
double original_Event_Y = 0;

double final_Event_X;
double final_Event_Y;

double change_X=0;
double change_Y=0;

bool change_Position = false;

bool change_Size = false;
double change_Scale_X;
double change_Scale_Y;





string dashboard_Name = "MA Crossing Dashboard";





//________________________________________________FUNCTIONS___________________________________________________________//


string pairs_List[];
int total_Pairs=0;


void getMarketPairs(){
    string temp_Pair_Name;

    for(int i=0; i< SymbolsTotal(true); i++){
       
                temp_Pair_Name = SymbolName(i,true);
                ArrayResize(pairs_List, total_Pairs+1);
                pairs_List[total_Pairs] = temp_Pair_Name;
                total_Pairs++;
                    if(total_Pairs>20) return;
    }
   
}



//---------------Object Creation functions------------------------//
void plotRectangle(double  passed_X, double passed_Y, double passed_Width, double passed_Height, int passed_Border, color passed_Color, string passed_Name, string passed_Tooltip=""){

//Values to be converted to integers before being used
int plot_Width  = (int)(passed_Width);
int plot_Height = (int)(passed_Height);
int plot_X      = (int)(passed_X);
int plot_Y      = (int)(passed_Y);
//--
                    ObjectCreate(0,passed_Name,OBJ_RECTANGLE_LABEL,0,0,0);     
                ObjectSetInteger(0,passed_Name,OBJPROP_XDISTANCE,plot_X);
                ObjectSetInteger(0,passed_Name,OBJPROP_YDISTANCE,plot_Y);
                ObjectSetInteger(0,passed_Name,OBJPROP_XSIZE,plot_Width);
                ObjectSetInteger(0,passed_Name,OBJPROP_YSIZE,plot_Height);
                ObjectSetInteger(0,passed_Name,OBJPROP_BGCOLOR,passed_Color);
                ObjectSetInteger(0,passed_Name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
                ObjectSetInteger(0,passed_Name,OBJPROP_STYLE,STYLE_SOLID);
                ObjectSetInteger(0,passed_Name,OBJPROP_WIDTH,passed_Border);
                 ObjectSetString(0,passed_Name,OBJPROP_TOOLTIP,passed_Tooltip);
                ObjectSetInteger(0,passed_Name,OBJPROP_BACK,false);
                ObjectSetInteger(0,passed_Name,OBJPROP_SELECTABLE,false);
                ObjectSetInteger(0,passed_Name,OBJPROP_SELECTED,false);
                ObjectSetInteger(0,passed_Name,OBJPROP_HIDDEN,false);
                ObjectSetInteger(0,passed_Name,OBJPROP_ZORDER,0);
}



void plotText(double passed_X, double passed_Y, double passed_Size, color passed_Color, string passed_Text,string passed_Name, string passed_Font="Arial", string passed_Tooltip=""){

//Values to be converted to integers before being used
int font_Size = (int)(passed_Size);
int plot_X    = (int)(passed_X);
int plot_Y    = (int)(passed_Y);

                ObjectCreate(0,passed_Name,OBJ_LABEL,0,0,0);
            ObjectSetInteger(0,passed_Name,OBJPROP_XDISTANCE,plot_X);
            ObjectSetInteger(0,passed_Name,OBJPROP_YDISTANCE,plot_Y);
            ObjectSetInteger(0,passed_Name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
             ObjectSetString(0,passed_Name,OBJPROP_TEXT,passed_Text);
             ObjectSetString(0,passed_Name,OBJPROP_FONT,passed_Font);
             ObjectSetString(0,passed_Name,OBJPROP_TOOLTIP,passed_Tooltip);
            ObjectSetInteger(0,passed_Name,OBJPROP_COLOR,passed_Color);
            ObjectSetInteger(0,passed_Name,OBJPROP_FONTSIZE,font_Size);
            ObjectSetInteger(0,passed_Name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
            ObjectSetInteger(0,passed_Name,OBJPROP_BACK,false);
            ObjectSetInteger(0,passed_Name,OBJPROP_SELECTABLE,false);
            ObjectSetInteger(0,passed_Name,OBJPROP_HIDDEN,false);
            ObjectSetInteger(0,passed_Name,OBJPROP_ZORDER,5);
}



void plotButton(double passed_X, 
                double passed_Y, 
                double passed_Width, 
                double passed_Height, 
                double passed_Size, 
                color  passed_Color, 
                color  passed_BG_Color, 
                string passed_Text,
                string passed_Name, 
                string passed_Tooltip=""){

//Values to be converted to integers before being used
int font_Size   = (int)(passed_Size);
int plot_X      = (int)(passed_X);
int plot_Y      = (int)(passed_Y);
int plot_Width  = (int)(passed_Width);
int plot_Height = (int)(passed_Height);

                ObjectCreate(0,passed_Name,OBJ_BUTTON,0,0,0);
            ObjectSetInteger(0,passed_Name,OBJPROP_XDISTANCE,plot_X);
            ObjectSetInteger(0,passed_Name,OBJPROP_YDISTANCE,plot_Y);
            ObjectSetInteger(0,passed_Name,OBJPROP_XSIZE,plot_Width);
            ObjectSetInteger(0,passed_Name,OBJPROP_YSIZE,plot_Height);
            ObjectSetInteger(0,passed_Name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
             ObjectSetString(0,passed_Name,OBJPROP_TEXT,passed_Text);
             ObjectSetString(0,passed_Name,OBJPROP_FONT,"Arial");
             ObjectSetString(0,passed_Name,OBJPROP_TOOLTIP,passed_Tooltip);
            ObjectSetInteger(0,passed_Name,OBJPROP_COLOR,passed_Color);
            ObjectSetInteger(0,passed_Name,OBJPROP_FONTSIZE,font_Size);
            ObjectSetInteger(0,passed_Name,OBJPROP_BGCOLOR,passed_BG_Color);
            ObjectSetInteger(0,passed_Name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
            ObjectSetInteger(0,passed_Name,OBJPROP_BACK,false);
            ObjectSetInteger(0,passed_Name,OBJPROP_SELECTABLE,false);
            ObjectSetInteger(0,passed_Name,OBJPROP_HIDDEN,false);
            ObjectSetInteger(0,passed_Name,OBJPROP_ZORDER,5);
}




int total_Timeframes = 0;

void countFrames(){
 if(show_M1   == SHOW) total_Timeframes++;
 if(show_M5   == SHOW) total_Timeframes++;
 if(show_M15  == SHOW) total_Timeframes++;
 if(show_M30  == SHOW) total_Timeframes++;
 if(show_H1   == SHOW) total_Timeframes++;
 if(show_H4   == SHOW) total_Timeframes++;
 if(show_D1   == SHOW) total_Timeframes++;
 if(show_W1   == SHOW) total_Timeframes++;
 if(show_MN1  == SHOW) total_Timeframes++;
}


void setHeaders(){
double plot_X = dash_X + pairs_Width;
double plot_Y = dash_Y + title_Height;

    //---- M1 -----//
    if(show_M1 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "M1", "X5-Header-M1", "Arial", "M1"); 
        plot_X   = plot_X + header_Width;
    }

    //---- M5 -----//
    if(show_M5 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "M5", "X5-Header-M5", "Arial", "M5"); 
        plot_X   = plot_X + header_Width;
    }

    //---- M15 -----//
    if(show_M15 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "M15", "X5-Header-M15", "Arial", "M15"); 
        plot_X   = plot_X + header_Width;
    }

    //---- M30 -----//
    if(show_M30 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "M30", "X5-Header-M30", "Arial", "M30"); 
        plot_X   = plot_X + header_Width;
    }

    //---- H1 -----//
    if(show_H1 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "H1", "X5-Header-H1", "Arial", "H1"); 
        plot_X   = plot_X + header_Width;
    }

    //---- H4 -----//
    if(show_H4 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "H4", "X5-Header-H4", "Arial", "H4"); 
        plot_X   = plot_X + header_Width;
    }

    //---- D1 -----//
    if(show_D1 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "D1", "X5-Header-D1", "Arial", "D1"); 
        plot_X   = plot_X + header_Width;
    }

    //---- W1 -----//
    if(show_W1 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "W1", "X5-Header-W1", "Arial", "W1"); 
        plot_X   = plot_X + header_Width;
    }

    //---- MN1 -----//
    if(show_MN1 == SHOW){
        plotText(plot_X+headers_Indent, plot_Y+headers_V_Indent, headers_Font_Size, headers_Color, "MN1", "X5-Header-MN1", "Arial", "MN1"); 
        plot_X   = plot_X + header_Width;
    }

}

color  row_Color;

//Print out the rows
void setRows(){ 

string pair_Name;
string obj_Name;
double plot_X = dash_X;
double plot_Y = dash_Y + title_Height + header_Height;

        for(int pair_i=0; pair_i<total_Pairs; pair_i++){

            plot_X=dash_X;

            pair_Name = pairs_List[pair_i];
            if(pair_i%2==0)row_Color=rows_Even_Color;
            if(pair_i%2!=0)row_Color=rows_Odd_Color;

            //Background 
            obj_Name = "X5-"+pair_Name+"-BG";
            plotRectangle(plot_X+2, plot_Y, dash_Width-10, row_Height, 1, row_Color, obj_Name, pair_Name);
            
            //Pair name
            obj_Name = "X5-Pair-"+pair_Name;
            plotText(plot_X+pairs_Indent, plot_Y+rows_V_Indent, pairs_Font_Size, pairs_Color, pair_Name, obj_Name, "Arial", pair_Name);


        //Timeframes
        plot_X   = plot_X + pairs_Width;


            //---- M1 -----//
            if(show_M1 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-M1-BG",pair_Name+"-M1");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-M1", "Arial", pair_Name+"-M1"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- M5 -----//
            if(show_M5 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-M5-BG",pair_Name+"-M5");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-M5", "Arial", pair_Name+"-M5"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- M15 -----//
            if(show_M15 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-M15-BG",pair_Name+"-M15");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-M15", "Arial", pair_Name+"-M15"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- M30 -----//
            if(show_M30 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-M30-BG",pair_Name+"-M30");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-M30", "Arial", pair_Name+"-M30"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- H1 -----//
            if(show_H1 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-H1-BG",pair_Name+"-H1");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-H1", "Arial", pair_Name+"-H1"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- H4 -----//
            if(show_H4== true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-H4-BG",pair_Name+"-H4");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-H4", "Arial", pair_Name+"-H4"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- D1 -----//
            if(show_D1 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-D1-BG",pair_Name+"-D1");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-D1", "Arial", pair_Name+"-D1"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- W1 -----//
            if(show_W1 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-W1-BG",pair_Name+"-W1");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-W1", "Arial", pair_Name+"-W1"); 
                plot_X   = plot_X + signals_Width;
            }

            //---- MN1 -----//
            if(show_MN1 == true){
                plotRectangle(plot_X, plot_Y, signals_Width, row_Height, 0, dash_Background_Color, "X5-"+pair_Name+"*-MN1-BG",pair_Name+"-MN1");
                plotText(plot_X+signals_Indent, plot_Y+rows_V_Indent, signals_Font_Size, bars_Count_Color, "", "X5-"+pair_Name+"-MN1", "Arial", pair_Name+"-MN1"); 
                plot_X   = plot_X + signals_Width;
            }

        //Next Row 
        plot_Y = plot_Y + row_Height;

        }

}


void plotDash(){



    //Plot the background
    plotRectangle(dash_X, dash_Y, dash_Width, dash_Height, 1, dash_Background_Color, "X5-background", dashboard_Name);



    //A little more design
    //plotRectangle(dash_X+indicator_Col_Width+gap_X, dash_Y, 4, dash_Height, 0, title_Background_Color, "X5-Column-Line");

    //Plot the title bar
    plotRectangle(dash_X, dash_Y, dash_Width, title_Height, 0, title_Background_Color, "X5-title-background",dashboard_Name);

    //Title
     plotText(dash_X+title_Indent, dash_Y+title_V_Indent, title_Font_Size, title_Color, dashboard_Name,"X5-title","Arial",dashboard_Name);
  

    //Close button
    plotText(dash_X+ dash_Width-close_Indent, dash_Y+title_V_Indent, minimise_Font_Size, dash_Buttons_Color, close_Icon, "X5-Close", "Arial", "Close");


    //Minimise button
    plotText(dash_X+dash_Width-minimise_Indent, dash_Y+title_V_Indent, minimise_Font_Size, dash_Buttons_Color, minimise_Icon, "X5-Minimise", "Arial", "Minimise");





    //Headers
    setHeaders();

    //Rows
   setRows();

ChartRedraw();

}

void killDash(){ //Dah only, not the minimise button
  ObjectsDeleteAll(0,"X5-");
}


bool adjustDashPosition(double passed_Change_X, double passed_Change_Y){

dash_X = dash_X + passed_Change_X;
dash_Y = dash_Y + passed_Change_Y;

    double plot_Y = dash_Y; 
    double plot_X = dash_X;

//backgrond
ObjectSetInteger(0,"X5-background",OBJPROP_XDISTANCE,(int)dash_X);
ObjectSetInteger(0,"X5-background",OBJPROP_YDISTANCE,(int)plot_Y);


//topbar
ObjectSetInteger(0,"X5-title-background",OBJPROP_XDISTANCE,(int)dash_X);
ObjectSetInteger(0,"X5-title-background",OBJPROP_YDISTANCE,(int)dash_Y);

//Title
    ObjectSetInteger(0,"X5-title",OBJPROP_XDISTANCE,(int)(dash_X+title_Indent));
    ObjectSetInteger(0,"X5-title",OBJPROP_YDISTANCE,(int)(dash_Y+title_V_Indent));

//Minimise button
    ObjectSetInteger(0,"X5-Minimise",OBJPROP_XDISTANCE,(int)(dash_X+dash_Width-minimise_Indent) );
    ObjectSetInteger(0,"X5-Minimise",OBJPROP_YDISTANCE,(int)(dash_Y+title_V_Indent) );

//Close button
    ObjectSetInteger(0,"X5-Close",OBJPROP_XDISTANCE,(int)(dash_X+ dash_Width-close_Indent) );
    ObjectSetInteger(0,"X5-Close",OBJPROP_YDISTANCE,(int)(dash_Y+title_V_Indent));


//----------------------------- Adjust the headers ----------------------------------------------------------------------------------

plot_X = dash_X + pairs_Width;
plot_Y = dash_Y + title_Height;

    //---- M1 -----//
    if(show_M1 == SHOW){
        ObjectSetInteger(0,"X5-Header-M1",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-M1",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- M5 -----//
    if(show_M5 == SHOW){
        ObjectSetInteger(0,"X5-Header-M5",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-M5",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- M15 -----//
    if(show_M15 == SHOW){
        ObjectSetInteger(0,"X5-Header-M15",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-M15",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- M30 -----//
    if(show_M30 == SHOW){
        ObjectSetInteger(0,"X5-Header-M30",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-M30",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- H1 -----//
    if(show_H1 == SHOW){
        ObjectSetInteger(0,"X5-Header-H1",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-H1",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- H4 -----//
    if(show_H4 == SHOW){
        ObjectSetInteger(0,"X5-Header-H4",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-H4",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- D1 -----//
    if(show_D1 == SHOW){
        ObjectSetInteger(0,"X5-Header-D1",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-D1",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }

    //---- W1 -----//
    if(show_W1 == SHOW){
        ObjectSetInteger(0,"X5-Header-W1",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-W1",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }


    //---- MN1 -----//
    if(show_MN1 == SHOW){
        ObjectSetInteger(0,"X5-Header-MN1",OBJPROP_XDISTANCE,(int)(plot_X+headers_Indent) );
        ObjectSetInteger(0,"X5-Header-MN1",OBJPROP_YDISTANCE,(int)(plot_Y+headers_V_Indent) );

        plot_X   = plot_X + header_Width;
    }



//----------------------------- Adjust the rows ----------------------------------------------------------------------------------

string pair_Name;
plot_X = dash_X;
plot_Y = dash_Y + title_Height + header_Height;

        for(int pair_i=0; pair_i<total_Pairs; pair_i++){

        pair_Name = pairs_List[pair_i]; 

            plot_X=dash_X;


            //Background 
            ObjectSetInteger(0,"X5-"+pair_Name+"-BG",OBJPROP_XDISTANCE,(int)(plot_X) );
            ObjectSetInteger(0,"X5-"+pair_Name+"-BG",OBJPROP_YDISTANCE,(int)(plot_Y));
            
            //Pair name
            ObjectSetInteger(0,"X5-Pair-"+pair_Name,OBJPROP_XDISTANCE,(int)(plot_X+pairs_Indent) );
            ObjectSetInteger(0,"X5-Pair-"+pair_Name,OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );


        //Timeframes
        plot_X   = plot_X + pairs_Width;

            //---- M1 -----//
            if(show_M1 == true){
        
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M1-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M1-BG",OBJPROP_YDISTANCE,(int)plot_Y );

                ObjectSetInteger(0,"X5-"+pair_Name+"-M1",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-M1",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );

                plot_X   = plot_X + signals_Width;
            }

            //---- M5 -----//
            if(show_M5 == true){
             
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M5-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M5-BG",OBJPROP_YDISTANCE,(int)plot_Y );
                
                ObjectSetInteger(0,"X5-"+pair_Name+"-M5",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-M5",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );

                plot_X   = plot_X + signals_Width;
            }

            //---- M15 -----//
            if(show_M15 == true){

                ObjectSetInteger(0,"X5-"+pair_Name+"*-M15-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M15-BG",OBJPROP_YDISTANCE,(int)plot_Y );         
             
                ObjectSetInteger(0,"X5-"+pair_Name+"-M15",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-M15",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );

                plot_X   = plot_X + signals_Width;
            }

            //---- M30 -----//
            if(show_M30 == true){
               
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M30-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-M30-BG",OBJPROP_YDISTANCE,(int)plot_Y );

                ObjectSetInteger(0,"X5-"+pair_Name+"-M30",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-M30",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );

                plot_X   = plot_X + signals_Width;
            }

            //---- H1 -----//
            if(show_H1 == true){
             
                ObjectSetInteger(0,"X5-"+pair_Name+"*-H1-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-H1-BG",OBJPROP_YDISTANCE,(int)plot_Y );

                ObjectSetInteger(0,"X5-"+pair_Name+"-H1",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-H1",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );
                
                plot_X   = plot_X + signals_Width;
            }

            //---- H4 -----//
            if(show_H4== true){

                ObjectSetInteger(0,"X5-"+pair_Name+"*-H4-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-H4-BG",OBJPROP_YDISTANCE,(int)plot_Y );       
                
                ObjectSetInteger(0,"X5-"+pair_Name+"-H4",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-H4",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );
                
                plot_X   = plot_X + signals_Width;
            }

            //---- D1 -----//
            if(show_D1 == true){
                
                ObjectSetInteger(0,"X5-"+pair_Name+"*-D1-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-D1-BG",OBJPROP_YDISTANCE,(int)plot_Y );

                ObjectSetInteger(0,"X5-"+pair_Name+"-D1",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-D1",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );
                
                plot_X   = plot_X + signals_Width;
            }

            //---- W1 -----//
            if(show_W1 == true){
              
                ObjectSetInteger(0,"X5-"+pair_Name+"*-W1-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-W1-BG",OBJPROP_YDISTANCE,(int)plot_Y );

                ObjectSetInteger(0,"X5-"+pair_Name+"-W1",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-W1",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );

                plot_X   = plot_X + signals_Width;
            }

            //---- MN1 -----//
            if(show_MN1 == true){
                
                ObjectSetInteger(0,"X5-"+pair_Name+"*-MN1-BG",OBJPROP_XDISTANCE,(int)plot_X );
                ObjectSetInteger(0,"X5-"+pair_Name+"*-MN1-BG",OBJPROP_YDISTANCE,(int)plot_Y );
                
                ObjectSetInteger(0,"X5-"+pair_Name+"-MN1",OBJPROP_XDISTANCE,(int)(plot_X+signals_Indent) );
                ObjectSetInteger(0,"X5-"+pair_Name+"-MN1",OBJPROP_YDISTANCE,(int)(plot_Y+rows_V_Indent) );

                plot_X   = plot_X + signals_Width;
            }

        //Next Row 
        plot_Y = plot_Y + row_Height;

        }

     original_Event_X = 0;
     original_Event_Y = 0;

ChartRedraw();
return true;
}//--------------------------------------------------------------------------------




datetime previous_Notification[50,11];

void updateRow(string passed_Pair, int passed_Pair_Index, ENUM_TIMEFRAMES passed_Timeframe, string passed_Tag, int passed_Tag_i){

string tool_Tip;

    //BUY
        if( MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, 0) >  MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, 0) ){

            tool_Tip = "Pair : "+passed_Pair+"\nTF : "+passed_Tag+"\nFast MA : "+DoubleToString(MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, 0),5)+"\nSlow MA :"+DoubleToString(MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, 0),5);
                //Set the Cell color
                ObjectSetInteger(0,"X5-"+passed_Pair+"*-"+passed_Tag+"-BG",OBJPROP_BGCOLOR,buy_Text_Color);

                // //Find the origin
                for(int Bar_i=0; Bar_i<200; Bar_i++){

                    if( MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, Bar_i) <= MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, Bar_i)  ){

                        tool_Tip += "\nCrossing : "+TimeToString(iTime(passed_Pair, passed_Timeframe, Bar_i) );
                        ObjectSetString(0, "X5-"+passed_Pair+"*-"+passed_Tag+"-BG", OBJPROP_TOOLTIP, tool_Tip);
                        ObjectSetString(0, "X5-"+passed_Pair+"-"+passed_Tag, OBJPROP_TOOLTIP, tool_Tip);
                        ObjectSetString(0, "X5-"+passed_Pair+"-"+passed_Tag, OBJPROP_TEXT, IntegerToString(Bar_i-1) );
                        break;
                    }
                }


            //Check if to send an alert
            if(  MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, 1) <  MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, 1) ){
                      
                      if( previous_Notification[passed_Pair_Index][passed_Tag_i] != iTime(passed_Pair,passed_Timeframe,0) ){

                            if( phone_Notification == SWITCH_ENABLE ){
                                SendNotification(dashboard_Name+"\n Pair : "+passed_Pair+"\n Timeframe : "+passed_Tag+"\nFast MA above Slow MA" );
                            }
                            if( email_Notification == SWITCH_ENABLE ){
                                SendMail(dashboard_Name," Pair : "+passed_Pair+"\n Timeframe : "+passed_Tag+"\nFast MA above Slow MA" );
                            }
                            if( alerts_Notification == SWITCH_ENABLE ){
                                Alert(dashboard_Name+" Pair : "+passed_Pair+" Timeframe : "+passed_Tag+"  Fast MA above Slow MA" );
                            }

                        previous_Notification[passed_Pair_Index][passed_Tag_i] = iTime(passed_Pair,passed_Timeframe,0);
                      }
            }


        }
    //Sell
        else if( MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, 0) <  MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, 0) ){

             tool_Tip = "Pair : "+passed_Pair+"\nTF : "+passed_Tag+"\nFast MA : "+DoubleToString(MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, 0),4)+"\nSlow MA :"+DoubleToString(MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, 0),4);

                //Set the Cell color
                ObjectSetInteger(0,"X5-"+passed_Pair+"*-"+passed_Tag+"-BG",OBJPROP_BGCOLOR,sell_Text_Color);

                // //Find the origin
                for(int Bar_i=0; Bar_i<200; Bar_i++){

                    if( MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, Bar_i) >= MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, Bar_i)  ){

                        tool_Tip += "\nCrossing : "+TimeToString(iTime(passed_Pair, passed_Timeframe, Bar_i) );
                        ObjectSetString(0, "X5-"+passed_Pair+"*-"+passed_Tag+"-BG", OBJPROP_TOOLTIP, tool_Tip);
                        ObjectSetString(0, "X5-"+passed_Pair+"-"+passed_Tag, OBJPROP_TOOLTIP, tool_Tip);
                        ObjectSetString(0, "X5-"+passed_Pair+"-"+passed_Tag, OBJPROP_TEXT, IntegerToString(Bar_i) );
                        break;
                    }
                }

            //Check if to send an alert
            if( MA(passed_Pair, passed_Timeframe, MA_1_Period, MA_1_Method, MA_1_Applied_Price, 1) > MA(passed_Pair, passed_Timeframe, MA_2_Period, MA_2_Method, MA_2_Applied_Price, 1) ){
                        if( previous_Notification[passed_Pair_Index][passed_Tag_i] != iTime(passed_Pair,passed_Timeframe,0) ){

                            if( phone_Notification == SWITCH_ENABLE ){
                                SendNotification(dashboard_Name+"\n Pair : "+passed_Pair+"\n Timeframe : "+passed_Tag+"\nFast MA below Slow MA" );
                            }
                            if( email_Notification == SWITCH_ENABLE ){
                                SendMail(dashboard_Name," Pair : "+passed_Pair+"\n Timeframe : "+passed_Tag+"\nFast MA below Slow MA" );
                            }
                            if( alerts_Notification == SWITCH_ENABLE ){
                                Alert(dashboard_Name+" Pair : "+passed_Pair+" Timeframe : "+passed_Tag+" Fast MA below Slow MA" );
                            }

                        previous_Notification[passed_Pair_Index][passed_Tag_i] = iTime(passed_Pair,passed_Timeframe,0);
                        }
            }



        }
}


void updateRows(){
        for(int pair_i=0; pair_i<total_Pairs; pair_i++){

       string  pair_Name = pairs_List[pair_i];


            if(show_M1 == true){
                updateRow(pair_Name, pair_i, PERIOD_M1, "M1", 1);
            }
            if(show_M5 == true){
                updateRow(pair_Name, pair_i, PERIOD_M5, "M5", 2);
            }
            if(show_M15 == true){
                updateRow(pair_Name, pair_i, PERIOD_M15, "M15", 3);
            }
            if(show_M30 == true){
                updateRow(pair_Name, pair_i, PERIOD_M30, "M30", 4);
            }
            if(show_H1 == true){
                updateRow(pair_Name, pair_i, PERIOD_H1, "H1", 5);
            }
            if(show_H4 == true){
                updateRow(pair_Name, pair_i, PERIOD_H4, "H4", 6);
            }
            if(show_D1 == true){
                updateRow(pair_Name, pair_i, PERIOD_D1, "D1", 7);
            }
            if(show_W1 == true){
                updateRow(pair_Name, pair_i, PERIOD_W1, "W1", 8);
            }
            if(show_MN1 == true){
                updateRow(pair_Name, pair_i, PERIOD_MN1, "MN1", 9);
            }
        }
}

    
double MA(string passed_Pair, ENUM_TIMEFRAMES passed_Timeframe, int passed_Period, ENUM_MA_METHODS passed_Method, ENUM_APPLIED_PRICE passed_Price, int passed_Shift){

    double MA_Value;

        if(passed_Method==MA_TTLP){
            MA_Value = iCustom(passed_Pair,  passed_Timeframe, indicators_Path, passed_Period, 1, passed_Price, 0, passed_Shift);
        }

        else{
            int Method_i = passed_Method;
            int Price_i  = passed_Price;

            MA_Value = iMA(passed_Pair, passed_Timeframe, passed_Period, 0, Method_i, Price_i, passed_Shift);
        }

    return MA_Value;
}






int OnInit()
  {
   IndicatorSetString(INDICATOR_SHORTNAME,dashboard_Name);

     
    if(SymbolSource == USER_LIST){
        if( StringSplit( User_Symbol_List_Inpt, User_Symbol_List_Separator,pairs_List )  > 0 ){
            total_Pairs = ArraySize(pairs_List);            
        }
        else{
            SymbolSource = AUTO_LIST;
            Print("ERROR! Could not understand your pairs list. Make sure you pairs are named correctly, separated by a comma(,)");
        }      
    }
    if(SymbolSource == AUTO_LIST){
        getMarketPairs();
    }


//Check on notifications
if( email_Notification == 1 && TerminalInfoInteger(TERMINAL_EMAIL_ENABLED)==0  ){
        Alert("Warning: Email Notifications disabled");
        Print("Warning: Email Notifications disabled.:: Click on tools->Options->Email, then check the box next to Enable");
}


if( phone_Notification == 1 && TerminalInfoInteger(TERMINAL_NOTIFICATIONS_ENABLED)==0  ){
    Alert("Warning: Phone Notifications disabled");
    Print("Warning: Phone Notifications disabled.:: Click on tools->Options->Notifications, then check the box next to Enable Push Notifications");
}





    //Get the chart width to set the minimise button position
     chart_Width =  (int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
     chart_Height =  (int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);

    // Get ready to receive mouse moves
    ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,0,1);


    //Get the dynams
    countFrames();


    //Re-set the dashboard dimensions
    dash_Height = title_Height + header_Height + row_Height*total_Pairs +2;
    dash_Width = pairs_Width + signals_Width*total_Timeframes+1 ;


    plotDash();

    EventSetMillisecondTimer(1000);
    //   prev was (15000)

    return(INIT_SUCCEEDED);
}






int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   return(rates_total);
  }

void OnTimer() {
    updateRows();
}





void OnDeinit(const int reason) {
   EventKillTimer();
   ObjectsDeleteAll(0,"X5-");
}




  //-------------------------------------------------------------------------------
  //--------------------------Chart Events------------------------------------------

void OnChartEvent(const int event_Id, const long& event_X, const double& event_Y,  const string& event_Name  ) {

        if(event_Id==CHARTEVENT_MOUSE_MOVE ){
            if(event_Name=="1" ){ //Left click button is down

                //-----------Reposition---------// 
                if(  (event_X > dash_X && event_X < (dash_X + dash_Width)  && //X- Axis
                    event_Y > dash_Y && event_Y < (dash_Y + title_Height) ) //Y- Axis
                    || change_Position == true ){ 
                        change_Position = true;
                    
                
                                if(original_Event_X==0){
                                    original_Event_X =(double) event_X;
                                    original_Event_Y =(double) event_Y;
                                }
                                    final_Event_X = (double)event_X;
                                    final_Event_Y =(double) event_Y;

                                    change_X =(double) (final_Event_X - original_Event_X)*2;
                                    change_Y =(double) (final_Event_Y - original_Event_Y)*2;


                        if(change_X!=0 || change_Y!=0 ){
                            adjustDashPosition(change_X, change_Y); 
                        }

                }
            }
        }


        if(event_Id==CHARTEVENT_CLICK ){
            original_Event_X = 0;
            original_Event_Y = 0;
            change_Position = false;
            change_Size = false;
            ObjectSetInteger(0,"X5-resize",OBJPROP_COLOR,title_Background_Color);
            ChartRedraw();
        }

        if(event_Id==CHARTEVENT_OBJECT_CLICK ){
        
                //------------Maximise button----------------------//
                if(event_Name == "X5-Maximise"){
                    plotDash();
                    dashboard_hidden = false;
                    ObjectDelete(0,"X5-Maximise");
                }
                
                //------------Minimise button----------------------//
                if(event_Name == "X5-Minimise"){
                    killDash();
                    dashboard_hidden = true;
                plotButton(chart_Width-120, 20, 110, 20,  8, title_Color, dash_Background_Color, dashboard_Name, "X5-Maximise", "Open\n"+dashboard_Name);
                    ChartRedraw();
                }

                //------------Close button----------------------//
                if(event_Name == "X5-Close"){
                    ChartIndicatorDelete(0,0,dashboard_Name);
                    ChartRedraw();
                }
                //-------------Open Pair ------------------//
                if( StringFind(event_Name,"X5-Pair-") >= 0 ) {


                        string clicked_Pair = StringSubstr(event_Name,8); //Get the symbol name from the object name

                        if( ChartSetSymbolPeriod(0,clicked_Pair,0) == false){   //Open the symbol on the current timeframe
                            Alert("ERROR ",GetLastError(),"  Could not open ",clicked_Pair);
                        }
                        else{
                            ObjectSetInteger(0,event_Name,OBJPROP_COLOR,active_Color);
                        }
                } 

                //-------------Open Timeframe ------------------//
                if( StringFind(event_Name,"X5-Header-") >= 0 ) {

                        string clicked_TF = StringSubstr(event_Name,10);                   

                        if( ChartSetSymbolPeriod(0, NULL, TagToTimeframe(clicked_TF) ) == false){   
                            Alert("ERROR ",GetLastError(),"  Could not open ",clicked_TF);
                        }
                        else{
                            ObjectSetInteger(0,event_Name,OBJPROP_COLOR,active_Color);
                        }
                } 

                //-------------Open Both ------------------//
                if( StringFind(event_Name,"*") >= 0 ) {

                    int marker_Index     = StringFind(event_Name,"*");
                    int pair_Length      = marker_Index - 3;
                    int timeframe_Start  = marker_Index+2;
                    int timeframe_End    = StringFind(event_Name,"-",timeframe_Start);
                    int timeframe_Length = timeframe_End - marker_Index - 2;
                    
                     string clicked_Pair = StringSubstr(event_Name, 3, pair_Length);
                     string clicked_TF = StringSubstr(event_Name, timeframe_Start, timeframe_Length);   

                       
                        if( ChartSetSymbolPeriod(0, clicked_Pair, TagToTimeframe(clicked_TF) ) == false){   
                            Alert("ERROR ",GetLastError(),"\nCould not open ",clicked_Pair,"  ",clicked_TF);
                        }
                        else{
                            ObjectSetInteger(0,"X5-Pair-"+clicked_Pair, OBJPROP_COLOR, active_Color);
                            ObjectSetInteger(0,"X5-"+clicked_Pair+"-"+clicked_TF, OBJPROP_COLOR, active_Color);
                            ObjectSetInteger(0,"X5-Header-"+clicked_TF, OBJPROP_COLOR, active_Color);
                            ObjectSetInteger(0,"X5-"+clicked_Pair+"*-"+clicked_TF+"-BG", OBJPROP_COLOR, active_Color);

                            
                        }
                } 
        }
}








ENUM_TIMEFRAMES TagToTimeframe(string tag){

    if(tag=="M1")  return PERIOD_M1;
    if(tag=="M5")  return PERIOD_M5;
    if(tag=="M15") return PERIOD_M15;
    if(tag=="M30") return PERIOD_M30;
    if(tag=="H1")  return PERIOD_H1;
    if(tag=="H4")  return PERIOD_H4;
    if(tag=="D1")  return PERIOD_D1;
    if(tag=="W1")  return PERIOD_W1;
    if(tag=="MN1") return PERIOD_MN1;

    return PERIOD_CURRENT;
}